# gcp_mlengine_model – Creates a GCP Model

New in version 2.9.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Represents a machine learning solution.
- A model can have multiple versions, each of which is a deployed, trained model ready to receive prediction requests. The model itself is just a container.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6
- requests >= 2.18.4
- google-auth >= 1.3.0

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---

auth_kind
string / required

Choices:
- application
- machineaccount
- serviceaccount

The type of credential used.

default_version dictionary |  | The default version of the model. This version will be used to handle prediction requests that do not specify a version.
| name string |  | The name specified for the version when it was created.
description string |  | The description specified for the model when it was created.
env_type string |  | Specifies which Ansible environment you're running this module within. This should not be set unless you know what you're doing. This only alters the User Agent string for any API requests.
labels dictionary |  | One or more labels that you can add, to organize your models.
name string / required |  | The name specified for the model.

online_prediction_console_logging
boolean

Choices:
- no
- yes

If true, online prediction nodes send stderr and stdout streams to Stackdriver Logging.

online_prediction_logging
boolean

Choices:
- no
- yes

If true, online prediction access logs are sent to StackDriver Logging.

project string |  | The Google Cloud Platform project to use.
regions list |  | The list of regions where the model is going to be deployed. Currently only one region per model is supported .
scopes list |  | Array of scopes to be used.
service_account_contents jsonarg |  | The contents of a Service Account JSON file, either in a dictionary or as a JSON string that represents it.
service_account_email string |  | An optional service account email address if machineaccount is selected and the user does not wish to use the default email.
service_account_file path |  | The path of a Service Account JSON file if serviceaccount is selected as type.

state
string

Choices:
- present ←
- absent

Whether the given object should exist in GCP

## Notes

Note

- for authentication, you can set service_account_file using the c(gcp_service_account_file) env variable.
- for authentication, you can set service_account_contents using the c(GCP_SERVICE_ACCOUNT_CONTENTS) env variable.
- For authentication, you can set service_account_email using the `GCP_SERVICE_ACCOUNT_EMAIL` env variable.
- For authentication, you can set auth_kind using the `GCP_AUTH_KIND` env variable.
- For authentication, you can set scopes using the `GCP_SCOPES` env variable.
- Environment variables values will only be used if the playbook values are not set.
- The service_account_email and service_account_file options are mutually exclusive.

## Examples

    - name: create a model
      gcp_mlengine_model:
        name: "{{ resource_name | replace('-', '_') }}"
        description: My model
        regions:
        - us-central1
        project: test_project
        auth_kind: serviceaccount
        service_account_file: "/tmp/auth.pem"
        state: present

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
defaultVersion complex | success | The default version of the model. This version will be used to handle prediction requests that do not specify a version.
| name string | success | The name specified for the version when it was created.
description string | success | The description specified for the model when it was created.
labels dictionary | success | One or more labels that you can add, to organize your models.
name string | success | The name specified for the model.
onlinePredictionConsoleLogging boolean | success | If true, online prediction nodes send stderr and stdout streams to Stackdriver Logging.
onlinePredictionLogging boolean | success | If true, online prediction access logs are sent to StackDriver Logging.
regions list | success | The list of regions where the model is going to be deployed. Currently only one region per model is supported .

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Google Inc. (@googlecloudplatform)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.